﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight;
using C1.Silverlight.Extended;
using System.Collections.Generic;

namespace C1Property_Editor
{
    public class ComboBoxEditor : C1ComboBox, ITypeEditorControl
    {

        public void Attach(PropertyAttribute property)
        {
            // 设置自定义控件与属性的绑定关系
            var binding = new System.Windows.Data.Binding(property.PropertyInfo.Name)
            {
                Mode = System.Windows.Data.BindingMode.TwoWay,
                Source = property.SelectedObject,
                ValidatesOnExceptions = true,
            };
            this.SetBinding(ComboBoxEditor.SelectedItemProperty, binding);
        }

        public ITypeEditorControl Create()
        {
            ComboBoxEditor cbe = new ComboBoxEditor();

            // 绑定 C1ComboBox 的 ItemsSource 属性
            LoadItems(cbe);

            return cbe;
        }

        
        private void LoadItems(ComboBoxEditor cbe)
        {
            List<KeyValuePair<string, string>> items = new List<KeyValuePair<string, string>>();
            items.Add(new KeyValuePair<string, string>("XA", "西安"));
            items.Add(new KeyValuePair<string, string>("BJ", "北京"));
            items.Add(new KeyValuePair<string, string>("TJ", "天津"));
            items.Add(new KeyValuePair<string, string>("SH", "上海"));
            items.Add(new KeyValuePair<string, string>("CQ", "重庆"));

            cbe.ItemsSource = items;
            cbe.DisplayMemberPath = "Value";
            cbe.SelectedValuePath = "Key";
        }

        public void Detach(PropertyAttribute property)
        {
            
        }

        public bool Supports(PropertyAttribute Property)
        {
            return Property.PropertyInfo.PropertyType == typeof(System.String);
        }

        public event System.ComponentModel.PropertyChangedEventHandler ValueChanged;
    }
}
